<html>
<head>
<title>OgrePlane.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgrePlane.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgrePlane_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="comment">// This file is based on material originally from:</span>
<a name="l00029"></a>00029 <span class="comment">// Geometric Tools, LLC</span>
<a name="l00030"></a>00030 <span class="comment">// Copyright (c) 1998-2010</span>
<a name="l00031"></a>00031 <span class="comment">// Distributed under the Boost Software License, Version 1.0.</span>
<a name="l00032"></a>00032 <span class="comment">// http://www.boost.org/LICENSE_1_0.txt</span>
<a name="l00033"></a>00033 <span class="comment">// http://www.geometrictools.com/License/Boost/LICENSE_1_0.txt</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="preprocessor">#ifndef __Plane_H__</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span><span class="preprocessor">#define __Plane_H__</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>&quot;</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="keyword">namespace </span>Ogre {
<a name="l00044"></a>00044 
<a name="l00061"></a><a class="code" href="classOgre_1_1Plane.html">00061</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>
<a name="l00062"></a>00062     {
<a name="l00063"></a>00063     <span class="keyword">public</span>:
<a name="l00066"></a>00066         <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a> ();
<a name="l00067"></a>00067         <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a> (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; rhs);
<a name="l00069"></a>00069         <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a> (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkNormal, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fConstant);
<a name="l00071"></a>00071         <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a> (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> a, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> b, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> c, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> d);
<a name="l00072"></a>00072         <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a> (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkNormal, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint);
<a name="l00073"></a>00073         <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a> (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint0, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint1,
<a name="l00074"></a>00074             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint2);
<a name="l00075"></a>00075 
<a name="l00080"></a><a class="code" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bc">00080</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bc" title="The &quot;positive side&quot; of the plane is the half space to which the plane normal points.">Side</a>
<a name="l00081"></a>00081         {
<a name="l00082"></a><a class="code" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bcaad112821a6c39f0097136ba5df53052a">00082</a>             <a class="code" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bcaad112821a6c39f0097136ba5df53052a">NO_SIDE</a>,
<a name="l00083"></a><a class="code" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bcac5f2b56ac439b77aad6dfc4031891be5">00083</a>             <a class="code" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bcac5f2b56ac439b77aad6dfc4031891be5">POSITIVE_SIDE</a>,
<a name="l00084"></a><a class="code" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bcaaf227c36d02442779fd4600d00580f5e">00084</a>             <a class="code" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bcaaf227c36d02442779fd4600d00580f5e">NEGATIVE_SIDE</a>,
<a name="l00085"></a><a class="code" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bca44420e1c49338ae721f298826e164935">00085</a>             BOTH_SIDE
<a name="l00086"></a>00086         };
<a name="l00087"></a>00087 
<a name="l00088"></a>00088         Side getSide (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint) <span class="keyword">const</span>;
<a name="l00089"></a>00089 
<a name="l00094"></a>00094         Side getSide (<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; rkBox) <span class="keyword">const</span>;
<a name="l00095"></a>00095 
<a name="l00105"></a>00105         Side getSide (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; centre, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; halfSize) <span class="keyword">const</span>;
<a name="l00106"></a>00106 
<a name="l00115"></a>00115         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getDistance (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint) <span class="keyword">const</span>;
<a name="l00116"></a>00116 
<a name="l00118"></a>00118         <span class="keywordtype">void</span> redefine(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint0, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint1,
<a name="l00119"></a>00119             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint2);
<a name="l00120"></a>00120 
<a name="l00122"></a>00122         <span class="keywordtype">void</span> redefine(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkNormal, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkPoint);
<a name="l00123"></a>00123 
<a name="l00131"></a>00131         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> projectVector(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; v) <span class="keyword">const</span>;
<a name="l00132"></a>00132 
<a name="l00142"></a>00142         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> normalise(<span class="keywordtype">void</span>);
<a name="l00143"></a>00143 
<a name="l00144"></a><a class="code" href="classOgre_1_1Plane.html#a3f97462d3822f6add8c070048f6c2d92">00144</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Plane.html#a3f97462d3822f6add8c070048f6c2d92">normal</a>;
<a name="l00145"></a><a class="code" href="classOgre_1_1Plane.html#a8e7de1712320968bee111002bc2938b8">00145</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Plane.html#a8e7de1712320968bee111002bc2938b8">d</a>;
<a name="l00146"></a>00146 
<a name="l00148"></a><a class="code" href="classOgre_1_1Plane.html#a06e8f4ea4698c322580c4299f6a12e07">00148</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator==</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00149"></a>00149 <span class="keyword">        </span>{
<a name="l00150"></a>00150             <span class="keywordflow">return</span> (rhs.<a class="code" href="classOgre_1_1Plane.html#a8e7de1712320968bee111002bc2938b8">d</a> == d &amp;&amp; rhs.<a class="code" href="classOgre_1_1Plane.html#a3f97462d3822f6add8c070048f6c2d92">normal</a> == normal);
<a name="l00151"></a>00151         }
<a name="l00152"></a><a class="code" href="classOgre_1_1Plane.html#adae7d1d5d43cbe44cd40fc1e86784268">00152</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#ga34a9308dc656f694883718bf8fa4f1c2" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator!=</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00153"></a>00153 <span class="keyword">        </span>{
<a name="l00154"></a>00154             <span class="keywordflow">return</span> (rhs.<a class="code" href="classOgre_1_1Plane.html#a8e7de1712320968bee111002bc2938b8">d</a> != d || rhs.<a class="code" href="classOgre_1_1Plane.html#a3f97462d3822f6add8c070048f6c2d92">normal</a> != normal);
<a name="l00155"></a>00155         }
<a name="l00156"></a>00156 
<a name="l00157"></a>00157         <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> std::ostream&amp; <a class="code" href="group__General.html#ga6d67d46d838de3b38264f17fb792cddc">operator&lt;&lt; </a>(std::ostream&amp; o, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; p);
<a name="l00158"></a>00158     };
<a name="l00159"></a>00159 
<a name="l00160"></a><a class="code" href="group__Math.html#gae00d718daa48567f6c010aad9d6dd92c">00160</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Plane&gt;::type</a> <a class="code" href="group__Math.html#gae00d718daa48567f6c010aad9d6dd92c">PlaneList</a>;
<a name="l00164"></a>00164 } <span class="comment">// namespace Ogre</span>
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
